#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int t;
    cin>>t;

    int n,m;
    vector<int> R(0);

    int raz = 0;
    int q = 1;

    for(int i=0;i<t;i++){
        raz = 0;
        q = 1;
        cin>>n>>m;

        long long a[n],b[m];

        for(int j=0;j<n;j++){
            cin>>a[j];
        }

        for(int r=0;r<m;r++){
            cin>>b[r];
        }
        sort(a,a+n);
        sort(b,b+m);

        raz = a[1]-a[0];
        for(int j=0;j<m;j++){
            if(abs(a[0]-b[i])%raz==0) q=0;
        }
        R.push_back(q);
    }
    for(int i=0;i<R.size();i++){
        cout<<R.at(i)<<endl;
    }
    return 0;
}